/// <reference types="node" />
import { BufferStreamLike } from "@reactive-js/node";
import { HttpClient } from "@reactive-js/http-common";
import { DisposableLike } from "@reactive-js/disposable";
import { HttpRequest } from "@reactive-js/http";
import { BrotliOptions, ZlibOptions } from "zlib";
import { HttpClientRequest } from "./interfaces";
export declare type HttpClientOptions = {
    readonly insecureHTTPParser?: boolean;
    readonly maxHeaderSize?: number;
};
export declare const createHttpClient: (options?: HttpClientOptions) => HttpClient<HttpRequest<BufferStreamLike>, BufferStreamLike & DisposableLike>;
export declare const withDefaultBehaviors: (options?: ZlibOptions | (BrotliOptions & {
    maxRedirects: number;
}) | undefined) => (httpClient: HttpClient<HttpRequest<BufferStreamLike>, BufferStreamLike & DisposableLike>) => HttpClient<HttpClientRequest, BufferStreamLike & DisposableLike>;
