import { createBrotliCompress, createDeflate, createGzip, createBrotliDecompress, createInflate, createGunzip, } from "zlib";
export const createEncodingCompressTransform = (encoding, options) => () => {
    switch (encoding) {
        case "br":
            return createBrotliCompress(options);
        case "deflate":
            return createDeflate(options);
        case "gzip":
            return createGzip(options);
        case "compress":
        case "identity":
            throw new Error("unsupported encoding");
    }
};
export const createEncodingDecompressTransform = (encoding, options) => () => {
    switch (encoding) {
        case "br":
            return createBrotliDecompress(options);
        case "deflate":
            return createInflate(options);
        case "gzip":
            return createGunzip(options);
        case "compress":
        case "identity":
            throw new Error("unsupported encoding");
    }
};
export const supportedEncodings = [
    "gzip",
    "deflate",
    "br",
];
export const getFirstSupportedEncoding = (acceptedEncodings) => acceptedEncodings.find(encoding => supportedEncodings.includes(encoding));
//# sourceMappingURL=httpContentEncoding.js.map