import db from "mime-db";
import { httpRequestIsCompressible } from "@reactive-js/http";
import { transform } from "@reactive-js/node";
import { isSome } from "@reactive-js/option";
import { pipe } from "@reactive-js/pipe";
import { createEncodingCompressTransform, getFirstSupportedEncoding, } from "./httpContentEncoding";
import { decodeHttpMessage, encodeCharsetHttpMessage } from "./httpMessage";
export const decodeHttpRequest = (options = {}) => request => decodeHttpMessage(request, options);
export const encodeHttpRequest = (options = {}) => request => {
    var _a;
    const { body, contentInfo } = request;
    const contentEncoding = getFirstSupportedEncoding((_a = request === null || request === void 0 ? void 0 : request.acceptedEncodings) !== null && _a !== void 0 ? _a : []);
    return isSome(contentEncoding) &&
        isSome(contentInfo) &&
        contentInfo.contentEncodings.length === 0 &&
        httpRequestIsCompressible(request, db)
        ? Object.assign(Object.assign({}, request), { body: pipe(body, transform(createEncodingCompressTransform(contentEncoding, options))), contentInfo: Object.assign(Object.assign({}, contentInfo), { contentEncodings: [contentEncoding], contentLength: -1 }) }) : request;
};
export const encodeCharsetHttpRequest = (contentType) => {
    const messageEncoder = encodeCharsetHttpMessage(contentType);
    return req => messageEncoder(req);
};
//# sourceMappingURL=httpRequest.js.map