/// <reference types="node" />
import { BrotliOptions, ZlibOptions } from "zlib";
import { HttpRequest, HttpResponse, MediaType } from "@reactive-js/http";
import { BufferStreamLike } from "@reactive-js/node";
import { Option } from "@reactive-js/option";
import { Operator } from "@reactive-js/pipe";
export declare const decodeHttpResponse: (options: BrotliOptions | ZlibOptions) => Operator<HttpResponse<BufferStreamLike>, HttpResponse<BufferStreamLike>>;
export declare type EncodeHttpResponseOptions = {
    readonly shouldEncode?: <T, TResp>(req: HttpRequest<T>, resp: HttpResponse<TResp>) => Option<boolean>;
};
export declare const encodeHttpResponse: <TReq>(request: HttpRequest<TReq>, options?: (EncodeHttpResponseOptions & BrotliOptions) | (EncodeHttpResponseOptions & ZlibOptions)) => Operator<HttpResponse<BufferStreamLike>, HttpResponse<BufferStreamLike>>;
export declare const encodeCharsetHttpResponse: (contentType: string | MediaType) => Operator<HttpResponse<string>, HttpResponse<BufferStreamLike>>;
